import mastodon
import random
import requests
import re

def randline(fname):
    with open(fname) as afile:
        line = next(afile)
        for num, aline in enumerate(afile, 2):
            if random.randrange(num) == 0:
                line = aline
    return line.strip()

def bot():
    genre = randline('genres.txt')
    if genre:
        genre += ' '
    beats = "lo-fi {}beats to {} and {} to".format(
        genre,
        randline('1syllableverbs.txt'), randline('2syllableverbs.txt'))
    print(beats)

    mdon = mastodon.Mastodon(
        access_token='token.secret',
        api_base_url='https://botsin.space')

    query = requests.get(f'https://www.youtube.com/results?search_query={beats}')
    match = re.search(r'\?v=([^"]+)"', query.text)
    if match:
        beats += f'\n\nhttps://youtube.com/watch?v={match.group(1)}'

    print(beats)
    mdon.status_post(beats)

if __name__ == '__main__':
    bot()
